#include "chdecl.h"
void CH_pshell_userrm(current, sched, cop)
#define ARGUMENTS 12
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 5: goto c17;
    case 3: goto c19;
    case 4: goto cb19;
    case 6: goto cb21;
    case 7: goto c22;
    case 8: goto cb23;
    case 9: goto c24;
    case 10: goto c27;
    case 11: goto c29;
    case 12: goto cb31;
    case 13: goto c32;
    case 14: goto cb33;
    case 15: goto c34;
    case 16: goto c37;
    case 17: goto c39;
    case 18: goto cb42;
    case 19: goto c43;
    case 20: goto cb44;
    case 21: goto c45;
    case 22: goto c48;
    case 23: goto c50;
    case 24: goto c52;
    case 25: goto cb55;
    case 26: goto c56;
    case 27: goto cb57;
    case 28: goto c58;
    case 29: goto c61;
    case 30: goto c63;
    case 31: goto c65;
    case 32: goto cb68;
    case 33: goto c69;
    case 34: goto cb70;
    case 35: goto c71;
    case 36: goto c74;
    case 37: goto c76;
    case 38: goto c79;
    case 39: goto c81;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* new_record 3.2 , 5 */
  if ((ch_val.record = new_record(5)) == nil) goto ch_depletion;
  (*(REF(3)DOT(2).tsdr)->finalize)(REF(3)DOT(2).value,F_DISCARD,sched);
  REF(3)DOT(2).value = ch_val; REF(3)DOT(2).tsdr = & dr_record;
/* new_inport 4 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val; REF(4).tsdr = & dr_inport;
/* connect 3.2.0 4 */
  if (REF(4).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(0).tsdr)->finalize)(REF(3)DOT(2)DOT(0).value
    ,F_DISCARD,sched);
  REF(4).value.inport->refcount++;
  REF(3)DOT(2)DOT(0).value.outport = REF(4).value.inport;
  REF(3)DOT(2)DOT(0).tsdr = & dr_outport;
/* new_inport 5 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val; REF(5).tsdr = & dr_inport;
/* connect 3.2.1 5 */
  if (REF(5).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(1).tsdr)->finalize)(REF(3)DOT(2)DOT(1).value
    ,F_DISCARD,sched);
  REF(5).value.inport->refcount++;
  REF(3)DOT(2)DOT(1).value.outport = REF(5).value.inport;
  REF(3)DOT(2)DOT(1).tsdr = & dr_outport;
/* new_inport 6 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).value = ch_val; REF(6).tsdr = & dr_inport;
/* connect 3.2.2 6 */
  if (REF(6).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(2).tsdr)->finalize)(REF(3)DOT(2)DOT(2).value
    ,F_DISCARD,sched);
  REF(6).value.inport->refcount++;
  REF(3)DOT(2)DOT(2).value.outport = REF(6).value.inport;
  REF(3)DOT(2)DOT(2).tsdr = & dr_outport;
/* new_inport 7 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val; REF(7).tsdr = & dr_inport;
/* connect 3.2.3 7 */
  if (REF(7).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(3).tsdr)->finalize)(REF(3)DOT(2)DOT(3).value
    ,F_DISCARD,sched);
  REF(7).value.inport->refcount++;
  REF(3)DOT(2)DOT(3).value.outport = REF(7).value.inport;
  REF(3)DOT(2)DOT(3).tsdr = & dr_outport;
/* new_inport 8 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).value = ch_val; REF(8).tsdr = & dr_inport;
/* connect 3.2.4 8 */
  if (REF(8).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(2)DOT(4).tsdr)->finalize)(REF(3)DOT(2)DOT(4).value
    ,F_DISCARD,sched);
  REF(8).value.inport->refcount++;
  REF(3)DOT(2)DOT(4).value.outport = REF(8).value.inport;
  REF(3)DOT(2)DOT(4).tsdr = & dr_outport;
/* copy 9 3.1 */
  if((ch_returncode = (REF(3)DOT(1).tsdr->copy)(& ch_val, REF(3)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).value = ch_val;
  REF(9).tsdr = datarepmap[REF(3)DOT(1).tsdr->number];
/* copy 10 3.0 */
  if((ch_returncode = (REF(3)DOT(0).tsdr->copy)(& ch_val, REF(3)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).value = ch_val;
  REF(10).tsdr = datarepmap[REF(3)DOT(0).tsdr->number];
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* discard 0 */
  (*(REF(0).tsdr)->finalize)(REF(0).value,F_DISCARD,sched);
  REF(0).tsdr = & dr_bottom;
c20:
c17:
/* noop */
  
c19:
  current->ip = 4;
cb19:
/* select 4 * 5 * 6 * 7 * 8 * , 1 */
  if ((ch_returncode = che_select((
          arguments[0] = DEF(4),
          arguments[1] = NO_OBJECT,
          arguments[2] = DEF(5),
          arguments[3] = NO_OBJECT,
          arguments[4] = DEF(6),
          arguments[5] = NO_OBJECT,
          arguments[6] = DEF(7),
          arguments[7] = NO_OBJECT,
          arguments[8] = DEF(8),
          arguments[9] = NO_OBJECT,
          arguments[9+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  if (current->ip == 4) return; else COMPUTE_TARGET;
c21:
  current->ip = 6;
cb21:
/* receive 11 4 */
  if ((ch_returncode = che_receive(DEF(11),DEF(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c22:
/* block , 2 */
  if((ch_returncode = che_block(QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 8;
cb23:
/* call 9.0 10 11.0 11.1 11.2 , 3 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(0),
          arguments[1] = DEF(10),
          arguments[2] = DEF(11)DOT(0),
          arguments[3] = DEF(11)DOT(1),
          arguments[4] = DEF(11)DOT(2),
          arguments[4+1] = nil,& arguments[0]),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c24:
/* return 11 */
  if (ch_caller = do_return(REF(11).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(11).value);
  REF(11).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 17 */
   goto c17;
c27:
/* return_exception 11 , 4 */
  if (ch_caller = do_return(REF(11).value)) {
    raise_user(QUAL(4),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(11),QUAL(4));
  REF(11).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c29:
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c31:
  current->ip = 12;
cb31:
/* receive 12 5 */
  if ((ch_returncode = che_receive(DEF(12),DEF(5),sched)) != Normal)
     goto ch_raise_exception;
  return;
c32:
/* block , 5 */
  if((ch_returncode = che_block(QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 14;
cb33:
/* call 9.1 10 12.0 12.1 12.2 , 6 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(1),
          arguments[1] = DEF(10),
          arguments[2] = DEF(12)DOT(0),
          arguments[3] = DEF(12)DOT(1),
          arguments[4] = DEF(12)DOT(2),
          arguments[4+1] = nil,& arguments[0]),QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
  return;
c34:
/* return 12 */
  if (ch_caller = do_return(REF(12).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(12).value);
  REF(12).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 17 */
   goto c17;
c37:
/* return_exception 12 , 7 */
  if (ch_caller = do_return(REF(12).value)) {
    raise_user(QUAL(7),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(12),QUAL(7));
  REF(12).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c39:
/* discard 12.1 */
  (*(REF(12)DOT(1).tsdr)->finalize)(REF(12)DOT(1).value,F_DISCARD,sched);
  REF(12)DOT(1).tsdr = & dr_bottom;
/* discard 12 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c42:
  current->ip = 18;
cb42:
/* receive 13 6 */
  if ((ch_returncode = che_receive(DEF(13),DEF(6),sched)) != Normal)
     goto ch_raise_exception;
  return;
c43:
/* block , 8 */
  if((ch_returncode = che_block(QUAL(8),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 20;
cb44:
/* call 9.2 10 13.0 13.1 13.2 , 9 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(2),
          arguments[1] = DEF(10),
          arguments[2] = DEF(13)DOT(0),
          arguments[3] = DEF(13)DOT(1),
          arguments[4] = DEF(13)DOT(2),
          arguments[4+1] = nil,& arguments[0]),QUAL(9),sched)) != Normal)
     goto ch_raise_exception;
  return;
c45:
/* return 13 */
  if (ch_caller = do_return(REF(13).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(13).value);
  REF(13).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 17 */
   goto c17;
c48:
/* return_exception 13 , 10 */
  if (ch_caller = do_return(REF(13).value)) {
    raise_user(QUAL(10),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(13),QUAL(10));
  REF(13).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c50:
/* return_exception 13 , 11 */
  if (ch_caller = do_return(REF(13).value)) {
    raise_user(QUAL(11),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(13),QUAL(11));
  REF(13).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c52:
/* discard 13.2 */
  (*(REF(13)DOT(2).tsdr)->finalize)(REF(13)DOT(2).value,F_DISCARD,sched);
  REF(13)DOT(2).tsdr = & dr_bottom;
/* discard 13 */
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  REF(13).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c55:
  current->ip = 25;
cb55:
/* receive 14 7 */
  if ((ch_returncode = che_receive(DEF(14),DEF(7),sched)) != Normal)
     goto ch_raise_exception;
  return;
c56:
/* block , 12 */
  if((ch_returncode = che_block(QUAL(12),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 27;
cb57:
/* call 9.3 10 14.0 14.1 14.2 , 9 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(3),
          arguments[1] = DEF(10),
          arguments[2] = DEF(14)DOT(0),
          arguments[3] = DEF(14)DOT(1),
          arguments[4] = DEF(14)DOT(2),
          arguments[4+1] = nil,& arguments[0]),QUAL(9),sched)) != Normal)
     goto ch_raise_exception;
  return;
c58:
/* return 14 */
  if (ch_caller = do_return(REF(14).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(14).value);
  REF(14).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 17 */
   goto c17;
c61:
/* return_exception 14 , 10 */
  if (ch_caller = do_return(REF(14).value)) {
    raise_user(QUAL(10),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(14),QUAL(10));
  REF(14).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c63:
/* return_exception 14 , 11 */
  if (ch_caller = do_return(REF(14).value)) {
    raise_user(QUAL(11),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(14),QUAL(11));
  REF(14).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c65:
/* discard 14.2 */
  (*(REF(14)DOT(2).tsdr)->finalize)(REF(14)DOT(2).value,F_DISCARD,sched);
  REF(14)DOT(2).tsdr = & dr_bottom;
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c68:
  current->ip = 32;
cb68:
/* receive 15 8 */
  if ((ch_returncode = che_receive(DEF(15),DEF(8),sched)) != Normal)
     goto ch_raise_exception;
  return;
c69:
/* block , 13 */
  if((ch_returncode = che_block(QUAL(13),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 34;
cb70:
/* call 9.4 10 15.0 , 14 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(4),
          arguments[1] = DEF(10),
          arguments[2] = DEF(15)DOT(0),
          arguments[2+1] = nil,& arguments[0]),QUAL(14),sched)) != Normal)
     goto ch_raise_exception;
  return;
c71:
/* return 15 */
  if (ch_caller = do_return(REF(15).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(15).value);
  REF(15).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 17 */
   goto c17;
c74:
/* return_exception 15 , 15 */
  if (ch_caller = do_return(REF(15).value)) {
    raise_user(QUAL(15),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(15),QUAL(15));
  REF(15).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c76:
/* discard 15 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).tsdr = & dr_bottom;
/* branch , 17 */
   goto c17;
c79:
/* endblock */
  che_endblock(sched);
c81:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
